<?php include 'header.php' ?>
<?php
include 'config.php';
$sql = "SELECT * FROM slider";
$result = mysqli_query($db, $sql);

if (mysqli_num_rows($result) > 0) {
    $getAllSlider = mysqli_fetch_all($result, MYSQLI_ASSOC);
} else {
    $getAllSlider = array();
}

// Insertion Logic
if (isset($_POST['saveSliderBtn']) && !empty($_FILES['img']['name'])) {
    $alt = ucwords($_POST['alt']);
    $status = 1;
    
        if (isset($_FILES['img']['name']) && !empty($_FILES['img']['name'])) {
            $extensions = array("jpg", "jpeg", "png", "gif", "JPG", "PNG", "JPEG", "webp", "WEBP");
            $target_dir = $DOC_ROOT . "assets/slider";
            $tmpFilePath = $_FILES['img']['tmp_name'];
            $target_file = $target_dir . basename($_FILES["img"]["name"]);
            $imageFileType = pathinfo($target_file, PATHINFO_EXTENSION);

            if ($tmpFilePath != "") {
                if (in_array($imageFileType, $extensions)) {
                    $data = time();
                    $filename = $data . '_' . $_FILES['img']['name'];

                    if (move_uploaded_file($tmpFilePath, $target_dir . '/' . $filename)) {
                        
                        $sql = "INSERT INTO slider (id, image, alt, added_on) VALUES (null, '$filename', '$alt', current_timestamp())";
                        if (mysqli_query($db, $sql)) {
                            echo '<script>alert("Slider added successfully");window.location.href="slider.php"</script>';
                        } else {
                            echo '<script>alert("Something went wrong, Please try again.");window.location.href="slider.php"</script>';
                        }
                    }
                }
            }
        }
     else {
        echo '<script>alert("Oops! The size limit for images is 1 MB. Reduce the file size and try again.");window.location.href="slider.php"</script>';
    }
}


// Deletion Logic
if ($_SERVER['REQUEST_METHOD'] === 'GET' && isset($_GET['delete']) && isset($_GET['id'])) {
    $idToDelete = $_GET['id'];

    $stmt = $db->prepare("SELECT image FROM slider WHERE id = ?");
    $stmt->bind_param("i", $idToDelete);
    $stmt->execute();
    $stmt->bind_result($imageToDelete);
    $stmt->fetch();
    $stmt->close();

    $stmt = $db->prepare("DELETE FROM slider WHERE id = ?");
    $stmt->bind_param("i", $idToDelete);
    if (!$stmt) {
        echo "Error: " . mysqli_error($db);
    }

    if ($stmt->execute()) {
        $target_dir = $DOC_ROOT . "assets/slider/";
        $fileToDelete = $target_dir . $imageToDelete;

        if (file_exists($fileToDelete)) {
            unlink($fileToDelete);
        }

        echo '<script>
                alert("Record and Image have Been Successfully Deleted");
                setTimeout(function() {
                  window.location.href = "slider.php";
                }, 100); 
              </script>';
    } else {
        echo "Error deleting record: " . $stmt->error;
    }

    $stmt->close();
}

?>
<!-- Content wrapper -->
<div class="content-wrapper">
    <!-- Content -->
    <div class="container-fluid">
        <div class="row">

            <div class="col-md-12">
                <div class="card card-primary card-outline">
                    <div class="card-header" data-card-widget="collapse">
                        <h3 class="card-title">Add Slider</h3>

                        <div class="card-tools">
                            <button type="button" class="btn btn-tool">
                                <i class="fas fa-plus"></i>
                            </button>
                        </div>
                    </div>
                    <div class="card-body p-4" style="display: block;;">
                        <form action="" method="post" enctype="multipart/form-data">
                            <input type="hidden" name="idEdit" value="">
                            <div class="row">
                                <div class="form-group col-md-6">
                                    <label>Slider Image (Max size 1MB)</label>
                                    <input type="file" class="form-control" name="img" onchange="galleryImage(this)"
                                        required accept="image/*" id="sliderimg">
                                </div> 
                                <div class="form-group col-md-6">
                                    <label>ALT Tag (Keyword)</label>
                                    <input type="text" class="form-control" name="alt" required>
                                </div> 
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label>Uploaded Image</label>
                                        <img id="gall_img" src="" style="width:180px;">
                                    </div>
                                </div>
                                
                                

                            </div>
                    </div>
                    <div class="card-footer">
                        <button type="submit" name="saveSliderBtn" class="btn btn-info float-right"><i
                                class="fa fa-floppy-o">
                            </i> Save</button>
                        <a href="slider.php" class="btn btn-default"><i class="fa fa-refresh"> </i> Reset</a>
                    </div>
                    </form>
                </div>



                <div class="card card-primary card-outline">
                    <div class="card-header">
                        <h3 class="card-title">View Slider</h3>
                    </div>
                    <form action="" method="post" enctype="multipart/form-data">
                        <div class="card-body table-responsive p-0" style="min-height: 300px;">
                            <table class="table table-head-fixed text-nowrap">
                                <thead>
                                    <tr>
                                        <th>#</th>
                                        <th>Image</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <?php $iiDD = 1;
                                    foreach ($getAllSlider as $key => $values) { ?>
                                        <tr>
                                            <td>
                                                <?php echo $iiDD++; ?>
                                            </td>
                                            <td>
                                                <img src="assets/slider/<?php echo $values['image']; ?>" alt=""
                                                    width='55px'>
                                            </td>
                                            


                                            <td>
                                                <div class="dropdown">
                                                    <button type="button" class="btn p-0 dropdown-toggle hide-arrow"
                                                        data-bs-toggle="dropdown"><i
                                                            class="bx bx-dots-vertical-rounded"></i></button>
                                                    <div class="dropdown-menu">

                                                        <a class="dropdown-item deleteitems"
                                                            href="slider.php?id=<?php echo $values['id']; ?>&delete=true"
                                                            title="Delete"><i class="bx bx-trash me-1"></i> Delete</a>
                                                    </div>
                                                </div>
                                            </td>

                                        </tr>
                                    <?php } ?>
                                </tbody>
                            </table>
                        </div>
                    </form>
                </div>

            </div>
        </div>
        <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
        <script>
            function galleryImage(input) {
                if (input.files && input.files[0]) {
                    var reader = new FileReader();
                    reader.onload = function (e) {
                        $('#gall_img')
                            .attr('src', e.target.result);
                    };
                    reader.readAsDataURL(input.files[0]);
                }
            }
            function applyFileValidation(inputId, maxFileSize, allowedExtensions) {
                var fileInput = document.getElementById(inputId);

                fileInput.addEventListener('change', function () {
                    if (fileInput.files.length > 0) {
                        var file = fileInput.files[0];
                        var fileSize = file.size;
                        var fileExtension = file.name.split('.').pop().toLowerCase();

                        if (fileSize > maxFileSize) {
                            alert('File size exceeds ' + (maxFileSize / 1024) + 'KB. Please choose a smaller file.');
                            fileInput.value = '';
                        } else if (allowedExtensions.indexOf(fileExtension) === -1) {
                            alert('Invalid file type.');
                            fileInput.value = '';
                        }
                    }
                });
            }

            applyFileValidation('sliderimg', 1024*1024, ['jpg', 'jpeg', 'png', 'gif', 'JPG', 'PNG', 'JPEG', 'webp', 'WEBP']);

            const deleteItems = document.querySelectorAll('.deleteitems');
            deleteItems.forEach(function (element) {
                element.addEventListener('click', function (event) {
                    event.preventDefault();
                    return swal({
                        title: "Are you sure?",
                        text: "Once deleted, you will not be able to recover this Data!",
                        icon: "warning",
                        buttons: true,
                        dangerMode: true,
                    }).then((willDelete) => {
                        if (willDelete) {
                            window.location.href = this.getAttribute("href");
                        } else {
                            swal("Your Data is safe!");
                        }
                    });
                });
            });

        </script>
        <?php include 'footer.php' ?>