<?php
include 'config.php';

// Fetch the aimage file name from the database
$stmt = $db->prepare("SELECT aimage FROM design");
$stmt->execute();
$stmt->bind_result($cimageFileName);
$stmt->fetch();
$stmt->close();

$imagePath = "assets/certificatedesign/" . $cimageFileName;

// Fetch student data
if (isset($_GET['idEdit']) && !empty($_GET['idEdit'])) {
    $idEdit = $_GET['idEdit'];

    $filmId = mysqli_real_escape_string($db, $idEdit);
    $sql = "SELECT * FROM students WHERE id = $filmId";
    $result = mysqli_query($db, $sql);

    if ($result && mysqli_num_rows($result) > 0) {
        $getFilmEdit = mysqli_fetch_assoc($result);

        $stmt = $db->prepare("SELECT aimage FROM design");
        $stmt->execute();
        $stmt->bind_result($cimage);
        $stmt->fetch();
        $stmt->close();
    }
}
?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Student Admission Form</title>
    <style>
        /* Add your CSS styles here */
        body {
            text-align: center;
            text-transform:uppercase;
        }

        .certificate-container {
            position: relative;
            width: 100%;
            max-width: 800px;
            margin: 0 auto;
        }

        img.certificate {
            width: 100%;
            height: 100%;
            display: block;
        }

        img.student {
            position: absolute;
    top: 27%;
    left: 82%;
    transform: translate(-40%, -135%);
    width: 90px;
    height: 100px;
        }
        img.signature {
            position: absolute;
            top: 68%;
            left: 82%;
            transform: translate(-120%, -260%);
            width: 80px;
            height: 30px;
        }
        .date{
            position: absolute;
            top: 32.4%;
            left: 32%;
            transform: translate(-40%, -135%);
            width: 80px;
            height: 70px;
            
        }
        .course{
            position: absolute;
            top: 32%;
            left: 22%;
            transform: translate(-40%, -135%);
        }
        .name{
            position: absolute;
            top: 38%;
            left: 14%;
            transform: translate(-40%, -135%);
        }
        .father{
            position: absolute;
            top: 38%;
            left: 35%;
            transform: translate(-40%, -135%);
        }
        .mother{
            position: absolute;
            top: 38%;
            left: 77%;
            transform: translate(-40%, -135%);
        }
        .aadhar{
            position: absolute;
            top: 43.7%;
            left: 14%;
            transform: translate(-40%, -135%);
        }
        .mobile{
            position: absolute;
            top: 43.7%;
            left: 40%;
            transform: translate(-40%, -135%);
        }
        .altmobile{
            position: absolute;
            top: 43.7%;
            left: 70%;
            transform: translate(-40%, -135%);
        }
        .gender{
            position: absolute;
            top: 49.3%;
            left: 16%;
            transform: translate(-40%, -135%);
        }
        .email{
            position: absolute;
            top: 49.3%;
            left: 41%;
            transform: translate(-40%, -135%);
        }
        .dob{
            position: absolute;
            top: 49.3%;
            left: 68%;
            transform: translate(-40%, -135%);
        }
        .caste{
            position: absolute;
            top: 54.5%;
            left: 12%;
            transform: translate(-40%, -135%);
        }
        .highqualification{
            position: absolute;
            top: 54.5%;
            left: 26%;
            transform: translate(-40%, -135%);
        }
        .occupation{
            position: absolute;
            top: 54.5%;
            left: 50%;
    font-size: 10px;
            transform: translate(-40%, -135%);
        }
        .state{
            position: absolute;
            top: 54.5%;
                left: 66%;
    font-size: 10px;

            transform: translate(-40%, -135%);
        }
        .postcode{
            position: absolute;
            top: 54.5%;
            left: 81%;
            transform: translate(-40%, -135%);
        }
        .address{
            position: absolute;
            top: 63%;
            left: 25%;
            transform: translate(-40%, -135%);
            /*white-space: pre-wrap;*/
            width: 380px;
        }
        .minfees{
            position: absolute;
            top: 71%;
            left: 12%;
            transform: translate(-40%, -135%);
            
        }
        .feesreceived{
            position: absolute;
            top: 71%;
            left: 40%;
            transform: translate(-40%, -135%);
           
        }
        .balance{
            position: absolute;
            top: 71%;
            left: 70%;
            transform: translate(-40%, -135%);
           
        }
        
    </style>

</head>

<body>
    <!-- Display the certificate image -->

    <div class="certificate-container">


        <img src="<?php echo $imagePath; ?>" alt="Certificate" class="certificate">
        <img src="assets/students/<?php echo $getFilmEdit['image']; ?>" class='student'>
        <img src="assets/signature/<?php echo $getFilmEdit['signature']; ?>" class='signature'
                                    alt="Signature Image">
        <p class="date">
        <?php echo date('Y-m-d', strtotime($getFilmEdit['dt'])); ?>
        </p>
        <p class="course">
        <?php echo $getFilmEdit['awards']; ?> In <?php echo $getFilmEdit['course']; ?>
        </p>
        <p class="name">
        <?php echo $getFilmEdit['abbr'] . ' ' . $getFilmEdit['name']; ?>
        </p>
        <p class="father">
        <?php echo $getFilmEdit['father']; ?>
        </p>
        <p class="mother">
        <?php echo $getFilmEdit['mother']; ?>
        </p>
        <p class="aadhar">
        <?php echo $getFilmEdit['aadhar']; ?>
        </p>
        <p class="mobile">
        <?php echo $getFilmEdit['mobile']; ?>
        </p>
        <p class="altmobile">
        <?php echo $getFilmEdit['altmobile']; ?>
        </p>
        <p class="gender">
        <?php echo $getFilmEdit['gender']; ?>
        </p>
        <p class="email">
        <?php echo $getFilmEdit['email']; ?>
        </p>
        <p class="dob">
        <?php echo $getFilmEdit['dob']; ?>
        </p>
        <p class="caste">
        <?php echo $getFilmEdit['caste']; ?>
        </p>
        <p class="highqualification">
        <?php echo $getFilmEdit['highqualification']; ?>
        </p>
        <p class="occupation">
        <?php echo $getFilmEdit['occupation']; ?>
        </p>
        <p class="state">
        <?php echo $getFilmEdit['state']; ?>
        </p>
        <p class="postcode">
        <?php echo $getFilmEdit['postcode']; ?>
        </p>
        <p class="address">
        <?php echo $getFilmEdit['address']; ?>
        </p>
        <p class="minfees">
        &#x20B9;<?php echo $getFilmEdit['minfees']; ?>
        </p>
        <p class="feesreceived">
        &#x20B9;<?php echo $getFilmEdit['feesreceived']; ?>
        </p>
        <p class="balance">
        &#x20B9;<?php echo $getFilmEdit['balance']; ?>
        </p>
    </div>
</body>

</html>