<?php include 'include/header.php'; ?>

    <!-- main-area -->
    <main class="main-area fix">

        <!-- breadcrumb-area -->
        <section class="breadcrumb__area breadcrumb__bg" data-background="assets/img/bg/breadcrumb_bg.jpg">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div class="breadcrumb__content">
                            <h3 class="title">All Courses</h3>
                            <nav class="breadcrumb">
                                <span property="itemListElement" typeof="ListItem">
                                    <a href="index.php" class="text-decoration-none">Home</a>
                                </span>
                                <span class="breadcrumb-separator"><i class="fas fa-angle-right"></i></span>
                                <span property="itemListElement" typeof="ListItem">All Courses</span>
                            </nav>
                        </div>
                    </div>
                </div>
            </div>
            <div class="breadcrumb__shape-wrap">
                <img src="assets/img/others/breadcrumb_shape01.svg" alt="img" class="alltuchtopdown">
                <img src="assets/img/others/breadcrumb_shape02.svg" alt="img" data-aos="fade-right" data-aos-delay="300">
                <img src="assets/img/others/breadcrumb_shape03.svg" alt="img" data-aos="fade-up" data-aos-delay="400">
                <img src="assets/img/others/breadcrumb_shape04.svg" alt="img" data-aos="fade-down-left" data-aos-delay="400">
                <img src="assets/img/others/breadcrumb_shape05.svg" alt="img" data-aos="fade-left" data-aos-delay="400">
            </div>
        </section>
        <!-- breadcrumb-area-end -->

        <!-- all-courses -->
        <section class="all-courses-area section-py-120">
            <div class="container">
                <div class="row">
                   
                    <div class="col-md-12">
                        
                    <div class="row courses__grid-wrap row-cols-1 row-cols-xl-3 row-cols-lg-2 row-cols-md-2 row-cols-sm-1">

                    <?php
			include("admin/config.php");

			$sql = "SELECT * FROM courses";
			$result = $db->query($sql);

			if ($result->num_rows > 0) {
				while ($row = $result->fetch_assoc()) {
					$imagePath = 'admin/assets/course/' . $row['image'];
					$cname = $row["courses"];
					$encodedSubmenu = urlencode($cname);
					echo '<div class="col">
                                        <div class="courses__item shine__animate-item">
                                            <div class="courses__item-thumb">
                                                <a href="course-detail.php/' . $encodedSubmenu . '" class="shine__animate-link">
                                                    <img src="' . $imagePath . '" alt="img">
                                                </a>
                                            </div>
                                            <div class="courses__item-content">
                                                <ul class="courses__item-meta list-wrap">
                                                    <li class="courses__item-tag">
                                                ' . $row["courseduration"] . ' Months
                                                </li>
                                                <li class="avg-rating">Minimum Fees : ₹' . $row["minimumfees"] . '</li>
                                                    
                                                </ul>
                                                <h5 class="title"><a href="course-detail.php/' . $encodedSubmenu . '" class="text-decoration-none">' . $row["awards"] . ' In ' . $row["courses"] . '</a></h5>
                                                
                                                <div class="courses__item-bottom">
                                                    <div class="button">
                                                        <a href="course-detail.php/' . $encodedSubmenu . '" class="text-decoration-none">
                                                            <span class="text">Enroll Now</span>
                                                            <i class="flaticon-arrow-right"></i>
                                                        </a>
                                                    </div>
                                                    <h5 class="price">₹' . $row["cprice"] . '<del class="text-danger"> ₹' . $row["cmrp"] . '</del></h5>
                                                </div>
                                            </div>
                                        </div>
                                    </div>';
                                }
                            } else {
                                echo "No Courses found.";
                            }
                
                           
                            ?>



                     </div>
                    </div>
                </div>
            </div>
        </section>
        <!-- all-courses-end -->

    </main>
    <!-- main-area-end -->

<?php include 'include/footer.php'; ?>